package	jp.co.sds_corp.volcano;

import java.awt.Dialog;
import java.awt.Frame;
import java.text.DecimalFormat;

import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;

import jp.co.sds_corp.util.common.CmnManifest;

/**
* バージョン情報を表示します。
*/
public class AboutDialog extends JDialog
{
	private static final long serialVersionUID = 1L;
	String	title;
	String	version;
	JLabel  lbl;
	JOptionPane pane;

	/**
	* versionを表示するダイアログを生成します。
	*/
	protected AboutDialog( Frame parent ) {
		super( parent, true );
		init();
	}

	/**
	* versionを表示するダイアログを生成します。
	*/
	protected AboutDialog( Dialog parent ) {
		super( parent, true );
		init();
	}

	/**
	* versionを表示するダイアログを生成します。
	*/
	protected AboutDialog() {
		super();
		init();
	}

	public void init() {
	    try {
			CmnManifest mn = new CmnManifest( getClass());
			title = mn.getTitle();
			version = mn.getVersion();
		} catch ( Exception e ) {
			e.printStackTrace();
		}
	}

	public void show() {
		lbl = createLabel();
		pane = new JOptionPane( lbl,
			JOptionPane.INFORMATION_MESSAGE, JOptionPane.DEFAULT_OPTION );

		String text = "Volcano";
		JDialog dlg = pane.createDialog( getParent(), text );
		dlg.setVisible(true);
	}

	JLabel createLabel() {
		DecimalFormat df = new DecimalFormat( "#,###" );
		Runtime rt = Runtime.getRuntime();
		String html =
			"<HTML>"
			+ title + " ver " + version + "<BR>"
			+ "<BR>"
			+ "Copyright (C) 1995-2005 S.D.S. all rights reserved.<BR>"
			+ "<A HREF='http://www.sds-corp.co.jp/'>http://www.sds-corp.co.jp/</A><BR>"
			+ "<HR color='gray'><BR>"
			+ "maxMemory=" + df.format( rt.maxMemory() ) + "<BR>"
			+ "totalMemory=" + df.format( rt.totalMemory() ) + "<BR>"
			+ "freeMemory=" + df.format( rt.freeMemory() ) + "<BR>"
			+ "</HTML>";
		JLabel lbl = new JLabel( html );
		return lbl;
	}

}
