package	jp.co.sds_corp.volcano;

import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Dictionary;
import java.util.Hashtable;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.JSpinner;
import javax.swing.JTextField;
import javax.swing.SpinnerNumberModel;
import javax.swing.SpringLayout;

import jp.co.sds_corp.util.window.WindowUtility;

public class SetupDialog extends JDialog
{
	private static final long serialVersionUID = 1L;
	Settings	set;
	JTextField	txtUrl;
	JTextField	txtRd;
	JSlider		slider;
	JSpinner	valWidth;
	JSpinner	valHeight;
	JSpinner	valReader;
	JComboBox	cmbType;
	String[]	arrType = {
		"video.quicktime", "video.x-msvideo", "video.mpeg"
	};

	public SetupDialog( Frame owner, Settings set ) {
		super( owner );
		this.set = set;
		createControl();
		setData();
	}

	protected void createControl() {
		WindowUtility.setHideOnEscape( this );
		setModal( true );
		setSize( 500, 250 );
		getContentPane().setLayout(
			new BoxLayout( getContentPane(), BoxLayout.Y_AXIS ));

		JPanel pnl = new JPanel();
		SpringLayout layout = new SpringLayout();
		pnl.setLayout( layout );
		JLabel lbl;
		lbl = new JLabel( "URL:" );
		layout.putConstraint( SpringLayout.WEST, lbl,
							5, SpringLayout.WEST, getContentPane() );
		layout.putConstraint( SpringLayout.NORTH, lbl,
							5, SpringLayout.NORTH, getContentPane() );
		pnl.add( lbl );
		txtUrl = new JTextField( 50 );
		layout.putConstraint( SpringLayout.WEST, txtUrl,
							5, SpringLayout.EAST, lbl );
		layout.putConstraint( SpringLayout.NORTH, txtUrl,
							0, SpringLayout.NORTH, lbl );
		pnl.add( txtUrl );

		lbl = new JLabel( "FrameRate:" );
		layout.putConstraint( SpringLayout.WEST, lbl,
							5, SpringLayout.WEST, getContentPane() );
		layout.putConstraint( SpringLayout.NORTH, lbl,
							10, SpringLayout.SOUTH, txtUrl );
		pnl.add( lbl );
		slider = new JSlider( 1, 10 );
		//slider.setMajorTickSpacing( 5 );
		slider.setMinorTickSpacing( 1 );
		slider.setPaintTicks( true );
		slider.setSnapToTicks( true );
		Dictionary<Integer,JLabel> dic = new Hashtable<Integer,JLabel>();
		dic.put( Integer.valueOf( 5 ), new JLabel( "5" ));
		dic.put(  Integer.valueOf( 10 ), new JLabel( "10" ));
		slider.setLabelTable( dic );
		slider.setPaintLabels( true );
		layout.putConstraint( SpringLayout.WEST, slider,
							5, SpringLayout.EAST, lbl );
		layout.putConstraint( SpringLayout.NORTH, slider,
							5, SpringLayout.SOUTH, txtUrl );
		pnl.add( slider );

		lbl = new JLabel( "Size:" );
		layout.putConstraint( SpringLayout.WEST, lbl,
							5, SpringLayout.WEST, getContentPane() );
		layout.putConstraint( SpringLayout.NORTH, lbl,
							5, SpringLayout.SOUTH, slider );
		pnl.add( lbl );
		valWidth = new JSpinner();
		layout.putConstraint( SpringLayout.WEST, valWidth,
							5, SpringLayout.EAST, lbl );
		layout.putConstraint( SpringLayout.NORTH, valWidth,
							0, SpringLayout.NORTH, lbl );
		pnl.add( valWidth );
		lbl = new JLabel( "×" );
		layout.putConstraint( SpringLayout.WEST, lbl,
							5, SpringLayout.EAST, valWidth );
		layout.putConstraint( SpringLayout.NORTH, lbl,
							0, SpringLayout.NORTH, valWidth );
		pnl.add( lbl );
		valHeight = new JSpinner();
		layout.putConstraint( SpringLayout.WEST, valHeight,
							5, SpringLayout.EAST, lbl );
		layout.putConstraint( SpringLayout.NORTH, valHeight,
							0, SpringLayout.NORTH, lbl );
		pnl.add( valHeight );

		lbl = new JLabel( "Reader:" );
		layout.putConstraint( SpringLayout.WEST, lbl,
							5, SpringLayout.WEST, getContentPane() );
		layout.putConstraint( SpringLayout.NORTH, lbl,
							10, SpringLayout.SOUTH, valWidth );
		pnl.add( lbl );
		valReader = new JSpinner();
		SpinnerNumberModel model = (SpinnerNumberModel )valReader.getModel();
		model.setMaximum( Integer.valueOf( 10 ));
		model.setMinimum( Integer.valueOf( 1 ));
		layout.putConstraint( SpringLayout.WEST, valReader,
							5, SpringLayout.EAST, lbl );
		layout.putConstraint( SpringLayout.NORTH, valReader,
							0, SpringLayout.NORTH, lbl );
		pnl.add( valReader );

		lbl = new JLabel( "ContentType:" );
		layout.putConstraint( SpringLayout.WEST, lbl,
							5, SpringLayout.WEST, getContentPane() );
		layout.putConstraint( SpringLayout.NORTH, lbl,
							10, SpringLayout.SOUTH, valReader );
		pnl.add( lbl );
		cmbType = new JComboBox( arrType );
		cmbType.setEditable( true );
		layout.putConstraint( SpringLayout.WEST, cmbType,
							5, SpringLayout.EAST, lbl );
		layout.putConstraint( SpringLayout.NORTH, cmbType,
							0, SpringLayout.NORTH, lbl );
		pnl.add( cmbType );

		getContentPane().add( pnl );

		JPanel btnPnl = new JPanel();
		btnPnl.setLayout( new BoxLayout( btnPnl, BoxLayout.X_AXIS ));
		JButton btnOk = new JButton( "OK" );
		btnOk.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent ev ) {
				onOk();
			}
		} );
		btnPnl.add( btnOk );
		JButton btnCan = new JButton( "Cancel" );
		btnCan.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent ev ) {
				onCancel();
			}
		} );
		btnPnl.add( btnCan );
		getContentPane().add( btnPnl );
		getRootPane().setDefaultButton( btnOk );
	}

	void onOk() {
		set.setUrl( txtUrl.getText() );
		// set.setInterval( slider.getValue() );
		set.setFrameRate( slider.getValue() );
		set.setWidth( ((Integer )valWidth.getValue()).intValue() );
		set.setHeight( ((Integer )valHeight.getValue()).intValue() );
		set.setReader( ((Integer )valReader.getValue()).intValue() );
		set.setContentType( (String )cmbType.getSelectedItem() );
		getOwner().repaint();
		setVisible(false);
	}

	void onCancel() {
		setVisible(false);
	}

	@Override
	public void setVisible(boolean visible) {
		if (visible) {
			setData();
		}
		super.setVisible(visible);
	}

	void setData() {
		txtUrl.setText( set.getUrl().toString() );
		slider.setValue( set.getFrameRate() );
		valWidth.setValue( Integer.valueOf( set.getWidth()) );
		valHeight.setValue( Integer.valueOf( set.getHeight()) );
		valReader.setValue( Integer.valueOf( set.getReader()) );
		cmbType.setSelectedItem( set.getContentType() );
	}

}
